#!/usr/bin/env python2

# system includes
import sys
import os
import numpy as np
import datetime as dt

# local includes
from aoi import AOI
from dynaoi import dynAOI

def main(argv):

  aoidir = "../../exp/bike/aoi/"
  aoifile = aoidir + "WarpingTriangle-hazards.aoi"
# print "aoifile = ", aoifile

  dynaoidict = {}
  dynaoilist = []

  dynaoi = None

  if(os.path.isfile(aoifile)):

    f = open(aoifile,'r')

    linelist = f.read().splitlines()

    for line in linelist:

      # read the time line of the form HH:MM:SS,XXX --> HH:MM:SS,XXX
      if '-->' in line:
        timein, separator, timeout = line.partition('-->')
#       print "timein, separator, timeout: ", timein, separator, timeout
        timein = timein.replace(',','.')
        timeout = timeout.replace(',','.')
#       print "timein:", timein
##      t = dt.datetime.strptime(timein,"%H:%M:%S.%f")
##      print "t: ", t
        hh, mm, ss = map(float,timein.split(':'))
        indelta = dt.timedelta(hours=hh, minutes=mm, seconds=ss)
 #      print "indelta: ", indelta
        hh, mm, ss = map(float,timeout.split(':'))
        outdelta = dt.timedelta(hours=hh, minutes=mm, seconds=ss)
 #      print "indelta: ", indelta
        if dynaoi is not None:
          dynaoi.timein(indelta)
          dynaoi.timeout(outdelta)

      elif 'v' in line:
        # strip off '\n' then split on delimiting character
        elements = line.strip().split(' ')

#       print "map(float,elements): ", map(float,elements[1:])
#       print "np.asarray(map(float,elements)): ", \
#                                      np.asarray(map(float,elements[1:]))
#       print "x1,y1: ", np.asarray(map(float,elements[1:3]))
#       print "x2,y2: ", np.asarray(map(float,elements[3:5]))

        aoi = AOI(map(float,elements[1:]))
#       aoi.dump()

        if dynaoi is not None:
          dynaoi.addAOI(aoi)

      elif len(line):
#       print "line: ", line, "len: ", len(line)
        index = int(line)
#       print "index: ", index

        if dynaoi is not None:
          dynaoilist.append(dynaoi)
          del dynaoi

        dynaoi = dynAOI(index)

  # here we need to add the last read in dynaoi to list
  if dynaoi is not None:
    dynaoilist.append(dynaoi)
    del dynaoi

# print "Read in ", len(dynaoilist), " dynaois"

  for daoi in dynaoilist:
    daoi.dump()

if __name__ == "__main__":
  main(sys.argv[1:])
